Bug 1283701 - Explore support for installing Docker images at installation time
Explore support for installing Docker images at installation time
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: anaconda (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Anaconda Maintenance Team
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-11-19 10:51 EST by Colin Walters
Modified: 2016-12-20 11:05 EST (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 11:05:47 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Experimental docker kickstart (requires lorax-docker-boot.iso) (1.41 KB, text/plain)
2015-12-01 20:12 EST, Brian Lane
no flags Details

  None (edit)
Description Colin Walters 2015-11-19 10:51:41 EST
See https://bugzilla.redhat.com/show_bug.cgi?id=884385#c34

Right now people are doing hacks in %post to pull Docker images, and there are many things suboptimal about that.

This bug is about exploring some sort of core/kickstart support for this, similar to what we have for `ostreesetup`.

It's worth also considering user interface support, but I know that's a *lot* more work.
Comment 1 Colin Walters 2015-11-19 11:03:52 EST
See https://bugzilla.redhat.com/show_bug.cgi?id=1166465#c17 for an original bug on this.

An example use case now is where Anaconda knows how to install RPMs like open-vm-tools, if we want to have privileged containers which act as services, they need to be installed at that time.

Another example: We're working on containerizing Kubernetes, and potentially taking it out of Atomic Host.  But many use cases will want this there by default, so having the container laid down at the same time as the host OS makes sense.
Comment 2 Radek Vykydal 2015-11-20 05:31:44 EST
Having some examples of the %post hacks could be a good starting point.
Comment 3 Colin Walters 2015-11-20 16:35:36 EST
Ian, I believe you were working on this?
Comment 6 Brian Lane 2015-12-01 20:12 EST
Created attachment 1101225 [details]
Experimental docker kickstart (requires lorax-docker-boot.iso)

I've done some experimenting with this, and I think it is worthwhile to just include docker in the boot.iso, it only adds about 12M and I may be able to trim some of that off in runtime-cleanup.tmpl

I have a kickstart that works with this custom boot.iso, docker is running in the host, not in the chroot, so there are no issues with mounting /dev/. I do bind mount /var/lib/docker/ to the target system which is much safer than trying to make the chroot look like a complete system.

It looks like docker-storage-setup only works with a LV named docker-pool? Is this correct? It would be nicer if the user could name it whatever they want and pass that on to docker.

I think the next thing to do is to add a docker kickstart command that accepts the VG name (from the created VGs), as well as other storage related commands. thoughts on what needs to be accepted would be appreciated, I'm still learning about docker. It would basically do what I've done in the %post --nochroot but I'm not sure what kinds of other things it would need to do. pulling an image obviously, but what else?
Comment 7 Brian Lane 2015-12-01 20:26:07 EST
I've uploaded my experimental f23 boot.iso here: https://alt.fedoraproject.org/pub/alt/anaconda/f23-docker-20151124.iso if you want to use the attached kickstart.
Comment 8 Fedora End Of Life 2016-11-24 08:35:03 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 9 Fedora End Of Life 2016-12-20 11:05:47 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.